Proxmox/misc/code-server.sh

97 lines
2.6 KiB
Bash
Raw Normal View History

2022-08-04 22:34:40 +02:00
#!/usr/bin/env bash
2023-02-07 18:15:22 +01:00
2024-01-01 18:13:05 +01:00
# Copyright (c) 2021-2024 tteck
2023-02-07 18:15:22 +01:00
# Author: tteck (tteckster)
# License: MIT
# https://github.com/tteck/Proxmox/raw/main/LICENSE
2023-01-10 21:01:30 +01:00
function header_info {
cat <<"EOF"
______ __ _____
/ ____/___ ____/ /__ / ___/___ ______ _____ _____
/ / / __ \/ __ / _ \ \__ \/ _ \/ ___/ | / / _ \/ ___/
/ /___/ /_/ / /_/ / __/ ___/ / __/ / | |/ / __/ /
\____/\____/\__,_/\___/ /____/\___/_/ |___/\___/_/
EOF
}
2022-08-04 22:34:40 +02:00
IP=$(hostname -I | awk '{print $1}')
2022-10-30 02:04:45 +01:00
YW=$(echo "\033[33m")
BL=$(echo "\033[36m")
RD=$(echo "\033[01;31m")
BGN=$(echo "\033[4;92m")
GN=$(echo "\033[1;92m")
DGN=$(echo "\033[32m")
CL=$(echo "\033[m")
2022-08-04 22:34:40 +02:00
BFR="\\r\\033[K"
HOLD="-"
CM="${GN}${CL}"
APP="Code Server"
hostname="$(hostname)"
set -o errexit
set -o errtrace
set -o nounset
set -o pipefail
shopt -s expand_aliases
alias die='EXIT=$? LINE=$LINENO error_exit'
trap die ERR
function error_exit() {
2022-10-30 02:04:45 +01:00
trap - ERR
local reason="Unknown failure occured."
local msg="${1:-$reason}"
local flag="${RD}‼ ERROR ${CL}$EXIT@$LINE"
echo -e "$flag $msg" 1>&2
exit $EXIT
2022-08-04 22:34:40 +02:00
}
2023-01-10 21:01:30 +01:00
clear
header_info
2023-01-31 09:40:43 +01:00
if command -v pveversion >/dev/null 2>&1; then echo -e "⚠️ Can't Install on Proxmox "; exit; fi
if [ -e /etc/alpine-release ]; then echo -e "⚠️ Can't Install on Alpine"; exit; fi
2022-08-04 22:34:40 +02:00
while true; do
read -p "This will Install ${APP} on $hostname. Proceed(y/n)?" yn
case $yn in
2022-10-30 02:04:45 +01:00
[Yy]*) break ;;
[Nn]*) exit ;;
*) echo "Please answer yes or no." ;;
2022-08-04 22:34:40 +02:00
esac
done
function msg_info() {
local msg="$1"
echo -ne " ${HOLD} ${YW}${msg}..."
}
function msg_ok() {
local msg="$1"
echo -e "${BFR} ${CM} ${GN}${msg}${CL}"
}
msg_info "Installing Dependencies"
apt-get update &>/dev/null
2024-04-26 06:47:18 +02:00
apt-get install -y curl &>/dev/null
2022-08-04 22:34:40 +02:00
apt-get install -y git &>/dev/null
msg_ok "Installed Dependencies"
2022-10-30 02:04:45 +01:00
VERSION=$(curl -s https://api.github.com/repos/coder/code-server/releases/latest |
grep "tag_name" |
awk '{print substr($2, 3, length($2)-4) }')
2022-08-04 22:34:40 +02:00
msg_info "Installing Code-Server v${VERSION}"
curl -fOL https://github.com/coder/code-server/releases/download/v$VERSION/code-server_${VERSION}_amd64.deb &>/dev/null
2024-04-26 07:04:05 +02:00
dpkg -i code-server_${VERSION}_amd64.deb &>/dev/null
2022-08-04 22:34:40 +02:00
rm -rf code-server_${VERSION}_amd64.deb
mkdir -p ~/.config/code-server/
2024-04-26 07:04:05 +02:00
systemctl enable -q --now code-server@$USER
2022-10-30 02:04:45 +01:00
cat <<EOF >~/.config/code-server/config.yaml
2022-08-04 22:34:40 +02:00
bind-addr: 0.0.0.0:8680
auth: none
password:
cert: false
EOF
2024-04-26 07:04:05 +02:00
systemctl restart code-server@$USER
2022-08-04 22:34:40 +02:00
msg_ok "Installed Code-Server v${VERSION} on $hostname"
echo -e "${APP} should be reachable by going to the following URL.
${BL}http://$IP:8680${CL} \n"